// Stopwatch.cpp : Implementation of CStopwatch

#include "stdafx.h"
#include "Stopwatch.h"


// CStopwatch

STDMETHODIMP CStopwatch::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IStopwatch
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CStopwatch::Start(void)
{
	if (QueryPerformanceCounter((LARGE_INTEGER*) &m_nStartTime))
		return S_OK;
	else 
		return E_FAIL;
}

STDMETHODIMP CStopwatch::ElapsedTime(FLOAT* Time)
{
  HRESULT hr;
  LARGE_INTEGER nStopTime;

  // Set the stop time immediately so that a minimum amount of
  // timer code is executed between the start and stop times
  if ( !QueryPerformanceCounter((LARGE_INTEGER*) &nStopTime)
      || (m_nStartTime.QuadPart == 0)) {
    // Either QPC failed or
    // start was not called before stop
    hr = E_FAIL;
  } else {
    *Time = (float) (nStopTime.QuadPart - m_nStartTime.QuadPart);
    *Time = (*Time / m_nFrequency.QuadPart)- m_Overhead;
    hr = S_OK;
  }
  return hr;
}

STDMETHODIMP CStopwatch::get_Overhead(FLOAT* pVal)
{
	*pVal=m_Overhead;

	return S_OK;
}

STDMETHODIMP CStopwatch::put_Overhead(FLOAT newVal)
{
	// TODO: Add your implementation code here
	m_Overhead=newVal;
	return S_OK;
}

STDMETHODIMP CStopwatch::Add(FLOAT a, FLOAT b, FLOAT* out)
{
	// TODO: Add your implementation code here

	(*out)=a+b;
	return S_OK;
}

STDMETHODIMP CStopwatch::Div(FLOAT a, FLOAT b, FLOAT* out)
{
	// TODO: Add your implementation code here
	if (b==0.0)
		return Error("Dzielenie przez zero",IID_IStopwatch,E_FAIL);
	*out=a/b;
	return S_OK;
}
